//===================================================================
// asb3000w.pas
//-------------------------------------------------------------------
//
// ASB-3000 Wrapper
//
//===================================================================
unit asb3000w;

interface

uses
  Windows;

const
	//-----------------------------------------------------------------
  // foCXANZXɊւ`
  //-----------------------------------------------------------------
  ASB3000_MAX_DEVICE					 = 16;						// őfoCX
  ASB3000_DEVICE_AUTO					 = Word(not 0);		// foCXw
  //-----------------------------------------------------------------
  // `lɊւ`
  //-----------------------------------------------------------------
  ASB3000_NUM_CH							 = 2;							// Ή`l
  ASB3000_CH1									 = 0;							// CH1
  ASB3000_CH2									 = 1;							// CH2
  //-----------------------------------------------------------------
  // foCXɊւ`
  //-----------------------------------------------------------------
  ASB3000_VID_LENGTH					 = 8;							// x_ʕ
  ASB3000_PID_LENGTH					 = 16;						// v_Ngʕ
  //-----------------------------------------------------------------
  // TvOXe[^X̒`
  //-----------------------------------------------------------------
  ASB3000_STS_STOP						 = $0;						// CxgȂ(~)
  ASB3000_STS_PRE_TRIG				 = $1;						// gK҂ɂȂȌ
  ASB3000_STS_WAIT_FOR_TRIG		 = $3;						// gK҂̏
  ASB3000_STS_TRIG_DETECT			 = $7;						// gK|
  ASB3000_STS_AUTO_RUN				 = $B;						// ^CAEgt[ōăX^[g
  //-----------------------------------------------------------------
  // G[R[h̒`
  //-----------------------------------------------------------------
  ASB3000_SUCCESS							 = 0;							// ُȂ
  ASB3000_ERR_SYSTEM					 = 1;							// VXeG[
  ASB3000_ERR_NO_DEVICE				 = 2;							// gp\ȃfoCX܂
  ASB3000_ERR_IN_USE					 = 3;							// w̃foCX͎gpł
  ASB3000_ERR_INVALID_DEVICENO = 4;							// sȃfoCXʔԍł
  ASB3000_ERR_INVALID_ARGUMENT = 5;							// sȈw肳܂
  ASB3000_ERR_INTERNAL				 = 6;							// G[ł
  ASB3000_ERR_TRANSFER_TIMEOUT = 7;							// f[^]^CAEgɂȂ܂
  ASB3000_ERR_TRANSFER_CANCEL	 = 8;							// f[^]LZ܂
  ASB3000_ERR_TRANSFER_FAIL		 = 9;							// f[^]s܂
  ASB3000_ERR_BUFF_OVERFLOW		 = 10;						// obt@I[o[t[܂
  ASB3000_ERR_MEMSIZE					 = 11;						// 擾TCYُł
  ASB3000_ERR_DEVICE					 = 12;						// foCXG[ł
  ASB3000_ERR_WRAPDLL					 = DWord(-1);			// bp[֐G[
  //-----------------------------------------------------------------
  // bZ[W̒`
  //-----------------------------------------------------------------
  WM_DATA_READY								 = 1;							// TvOf[^
  WM_DATA_THREAD_ERROR				 = 2;							// f[^擾pXbhG[
  //-----------------------------------------------------------------
  // ̑̒`
  //-----------------------------------------------------------------
  ASB3000_DEVICE_ID						 = $AB00;					// foCXID
  ASB3000_DLL_NAME						 = 'asb3000.dll';	// DLLt@C
  ASB3000_RES_VERT						 = 1024;					// \(1024|Cg)
  ASB3000_RES_VOLTPOS					 = 500;						// d|WV\
  ADBUFF_MAX_SIZE							 = 1000000;				// ݍőf[^
  ADDATA_MASK_BIT							 = $000003FF;			// rbg}XN
  //-----------------------------------------------------------------
  // eݒl̒`
  //-----------------------------------------------------------------
  // (d)XP[
  ASB3000_VOLTDIV_0						 = 0;							// 10mV  or 100mV
  ASB3000_VOLTDIV_1						 = 1;							// 20mV  or 200mV
  ASB3000_VOLTDIV_2						 = 2;							// 50mV  or 500mV
  ASB3000_VOLTDIV_3						 = 3;							// 100mV or 1V
  ASB3000_VOLTDIV_4						 = 4;							// 200mV or 2V
  ASB3000_VOLTDIV_5						 = 5;							// 500mV or 5V
  ASB3000_VOLTDIV_6						 = 6;							// 1V    or 10V
  ASB3000_VOLTDIV_7						 = 7;							// 2V    or 20V
  // v[u
  ASB3000_PROBE_X1						 = 1;							// 1:1
  ASB3000_PROBE_X10						 = 10;						// 10:1
  ASB3000_PROBE_X100					 = 100;						// 100:1
  // ͌
  ASB3000_CUP_DC							 = 0;							// DC
  ASB3000_CUP_AC							 = 1;							// AC
  // TCY
  ASB3000_MEMSIZE_10K					 = 0;							// 10kPoint
  ASB3000_MEMSIZE_100K				 = 1;							// 100kPoint
  ASB3000_MEMSIZE_1M					 = 2;							// 1MPoint
  // ()XP[
  ASB3000_TIMEDIV_10NS				 = 10;						// 10ns
  ASB3000_TIMEDIV_20NS				 = 20;						// 20ns
  ASB3000_TIMEDIV_50NS				 = 50;						// 50ns
  ASB3000_TIMEDIV_100NS				 = 100;						// 100ns
  ASB3000_TIMEDIV_200NS				 = 200;						// 200ns
  ASB3000_TIMEDIV_500NS				 = 500;						// 500ns
  ASB3000_TIMEDIV_1US					 = 1000;					// 1us
  ASB3000_TIMEDIV_2US					 = 2000;					// 2us
  ASB3000_TIMEDIV_5US					 = 5000;					// 5us
  ASB3000_TIMEDIV_10US				 = 10000;					// 10us
  ASB3000_TIMEDIV_20US				 = 20000;					// 20us
  ASB3000_TIMEDIV_50US				 = 50000;					// 50us
  ASB3000_TIMEDIV_100US				 = 100000;				// 100us
  ASB3000_TIMEDIV_200US				 = 200000;				// 200us
  ASB3000_TIMEDIV_500US				 = 500000;				// 500us
  ASB3000_TIMEDIV_1MS					 = 1000000;				// 1ms
  ASB3000_TIMEDIV_2MS					 = 2000000;				// 2ms
  ASB3000_TIMEDIV_5MS					 = 5000000;				// 5ms
  ASB3000_TIMEDIV_10M					 = 10000000;			// 10ms
  // gш
  ASB3000_BW_FULL							 = 0;							// FULL
  ASB3000_BW_20MHZ						 = 1;							// 20MHz
  // TvO[h
  ASB3000_SMP_REAL						 = 0;							// ATvO
  // ANCWV[h
  ASB3000_ACQ_SINGLE					 = 0;							// VOVbg
  ASB3000_ACQ_ROLL						 = 1;							// [
  // gK[h
  ASB3000_TMODE_AUTO					 = 0;							// I[g
  ASB3000_TMODE_NORMAL				 = 1;							// m[}
  ASB3000_TMODE_FREERUN				 = 2;							// t[
  // gK\[X
  ASB3000_TSRC_CH1						 = 0;							// CH1
  ASB3000_TSRC_CH2						 = 1;							// CH2
  ASB3000_TSRC_EXT						 = 2;							// O
  // gK͌
  ASB3000_TCUP_DC							 = 0;							// DC
  ASB3000_TCUP_LF							 = 1;							// LFrej
  ASB3000_TCUP_HF							 = 2;							// HFrej
  // gKX[v
  ASB3000_TSLP_POS						 = 0;							// (オ)
  ASB3000_TSLP_NEG						 = 1;							// ()
  // pXgK(pX)
  ASB3000_PULSE_NONE					 = 0;							// gp
  ASB3000_PULSE_UNDER					 = 1;							// pX
  ASB3000_PULSE_ABOVE					 = 2;							// pXȏ

type
	//-----------------------------------------------------------------
  // foCX\
  //-----------------------------------------------------------------
  TDEVINFO = record
  	VendorID:  array [0..ASB3000_VID_LENGTH - 1] of Byte;	// x_ʕ
    ProductID: array [0..ASB3000_PID_LENGTH - 1] of Byte;	// v_Ngʕ
    FirmVer:   Byte;																			// t@[EFÃo[W
    FpgaVer:   Byte;																			// FPGÃo[W
  end;
  //-----------------------------------------------------------------
  // TvOp[^\
  //-----------------------------------------------------------------
  TSETMODE = record
  	// ݒ
    dwVoltDiv:        array [0..ASB3000_NUM_CH - 1] of DWord;	// (d)XP[
    dwVoltPos:        array [0..ASB3000_NUM_CH - 1] of DWord;	// (d)|WV
    dwVertCoupling:   array [0..ASB3000_NUM_CH - 1] of DWord;	// ͌
    // ݒ
    dwMemSize:        DWord;																	// TCY
    dwSamplingTime:   DWord;																	// ()XP[
    dwBandWidth:      array [0..ASB3000_NUM_CH - 1] of DWord;	// gш
    dwSamplingMode:   DWord;																	// TvO[h
    dwAcqMode:        DWord;																	// ANCWV[h
    // gKݒ
    dwTrigMode:       DWord;																	// gK[h
    dwTrigSource:     DWord;																	// gK\[X
    dwTrigCoupling:   DWord;																	// gK͌
    dwTrigSlope:      DWord;																	// gKX[v
    dwTrigLevel:      DWord;																	// gKx
    dwTrigPos:        DWord;																	// gK|WV
    dwTrigDelay:      DWord;																	// gKfBC
    dwTrigPulse:      DWord;																	// pXgK(pX)
    dwTrigPulseWidth: DWord;																	// pXgK(pX)
  end;

//-------------------------------------------------------------------
// ֐̎gp錾
//-------------------------------------------------------------------
// DLL[h
function Asb3000wDllOpen: Boolean;
// DLLN[Y
function Asb3000wDllClose: Boolean;
// o[W擾
function Asb3000wGetVersion(var pdwDrvVer: DWord;
														var pdwDllVer: DWord): Boolean;
// foCX̌
function Asb3000wCreate(var pwDeviceNo: Word;
												hWnd: THandle;
                        uWMBase: Integer): Boolean;
// foCX̊J
function Asb3000wClose(wDeviceNo: Word): Boolean;
// foCX擾
function Asb3000wGetDevInfo(wDeviceNo: Word; var pDevInfo: TDEVINFO): Boolean;
// TCY擾
function Asb3000wGetMemSize(wDeviceNo: Word; var pdwMemSize: DWord): Boolean;
// TvO샂[h̐ݒ
function Asb3000wSetMode(wDeviceNo: Word; var pSetMode: TSETMODE): Boolean;
// TvOJn
function Asb3000wStartSampling(wDeviceNo: Word; dwInitArg: DWord): Boolean;
// TvO~
function Asb3000wStopSampling(wDeviceNo: Word): Boolean;
// TvOXe[^X擾
function Asb3000wGetStatus(wDeviceNo: Word;
													 var pdwStatus: DWord;
                           var pdwNumData: DWord;
                           var pvInitArg): Boolean;
// TvOf[^擾
function Asb3000wGetData(wDeviceNo: Word;
												 dwNumData: DWord;
                         var pdwData): Boolean;
// G[R[h
function Asb3000wGetLastError(wDeviceNo: Word): DWord;


implementation

{$J+}	// ^t萔̕ύX\RpCw

const
	hDLL: THandle = 0;	// DLLnh

type
	TAsb3000GetVersion = function(var pdwDrvVer: DWord;
  															var pdwDllVer: DWord): Boolean; stdcall;
  TAsb3000Create = function(var pwDeviceNo: Word;
  													hWnd: THandle;
                            uWMBase: Integer): Boolean; stdcall;
  TAsb3000Close = function(wDeviceNo: Word): Boolean; stdcall;
  TAsb3000GetDevInfo = function(wDeviceNo: Word; var pDevInfo: TDEVINFO): Boolean; stdcall;
  TAsb3000GetMemSize = function(wDeviceNo: Word; var pdwMemSize: DWord): Boolean; stdcall;
  TAsb3000SetMode = function(wDeviceNo: Word; var pSetMode: TSETMODE): Boolean; stdcall;
  TAsb3000StartSampling = function(wDeviceNo: Word; dwInitArg: DWord): Boolean; stdcall;
  TASb3000StopSampling = function(wDeviceNo: Word): Boolean; stdcall;
  TAsb3000GetStatus = function(wDeviceNo: Word;
  														 var pdwStatus: DWord;
                               var pdwNumData: DWord;
                               var pvInitArg): Boolean; stdcall;
  TAsb3000GetData = function(wDeviceNo: Word;
  													 dwNumData: DWord;
                             var pdwData): Boolean; stdcall;
  TAsb3000GetLastError = function(wDeviceNo: Word): DWord; stdcall;

// DLLGNX|[g֐AhX̊i[ϐ
var
	pAsb3000GetVersion: TAsb3000GetVersion;
  pAsb3000Create: TAsb3000Create;
  pAsb3000Close: TAsb3000Close;
  pAsb3000GetDevInfo: TAsb3000GetDevInfo;
  pAsb3000GetMemSize: TAsb3000GetMemSize;
  pAsb3000SetMode: TAsb3000SetMode;
  pAsb3000StartSampling: TAsb3000StartSampling;
  pAsb3000StopSampling: TAsb3000StopSampling;
  pAsb3000GetStatus: TAsb3000GetStatus;
  pAsb3000GetData: TAsb3000GetData;
  pAsb3000GetLastError: TAsb3000GetLastError;

function _GetDllExportFunc: Boolean; forward;

{$J-}

//-------------------------------------------------------------------
// 		DLL[h(񃍁[h̓G[Ƃ)
// 		
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wDllOpen: Boolean;
begin
	Result := False;
  if hDLL <> 0 then Exit;
  hDLL := LoadLibrary(ASB3000_DLL_NAME);
  if hDLL = 0 then Exit;
  if _GetDllExportFunc = False then begin
  	Asb3000wDllClose;	// DLL֐擾ɎŝDLLN[Y
    Exit;
  end;
  Result := True
end;
//-------------------------------------------------------------------
// 		DLLA[h(A[h̓G[Ƃ)
// 		
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wDllClose: Boolean;
begin
	Result := True;
  if hDLL = 0 then Exit;
  if True = FreeLibrary(hDLL) then hDLL := 0
  else Result := False;
end;
//-------------------------------------------------------------------
// 		o[W擾
// 		pdwDrvVer		hCõo[Wi[̈ւ̃|C^
//				pdwDllVer		DLL̃o[Wi[̈ւ̃|C^
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wGetVersion(var pdwDrvVer: DWord;
														var pdwDllVer: DWord): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pAsb3000GetVersion(pdwDrvVer, pdwDllVer);
end;
//-------------------------------------------------------------------
// 		foCX̌
// 		pwDeviceNo  gpfoCX̃foCXʔԍi[̈ւ
//										|C^
//				hWnd				DLLo郁bZ[W󂯎EBhẼnh
//				uWMBase			o郁bZ[WID̃x[Xl
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wCreate(var pwDeviceNo: Word;
												hWnd: THandle;
                        uWMBase: Integer): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pAsb3000Create(pwDeviceNo, hWnd, uWMBase);
end;
//-------------------------------------------------------------------
// 		foCX̊J
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wClose(wDeviceNo: Word): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pAsb3000Close(wDeviceNo);
end;
//-------------------------------------------------------------------
// 		foCX̎擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				pDevInfo		foCXi[\̂ւ̃|C^
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wGetDevInfo(wDeviceNo: Word; var pDevInfo: TDEVINFO): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pAsb3000GetDevInfo(wDeviceNo, pDevInfo);
end;
//-------------------------------------------------------------------
// 		TCY̎擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				pdwMemSize	Ă郁TCYi[̈ւ̃|C^
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wGetMemSize(wDeviceNo: Word; var pdwMemSize: DWord): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pAsb3000GetMemSize(wDeviceNo, pdwMemSize);
end;
//-------------------------------------------------------------------
// 		TvO샂[h̐ݒ
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				pSetMode		ݒi[Ă\̂̃|C^
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wSetMode(wDeviceNo: Word; var pSetMode: TSETMODE): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pAsb3000SetMode(wDeviceNo, pSetMode);
end;
//-------------------------------------------------------------------
// 		TvO̊Jn
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				dwInitArg		\(0w)
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wStartSampling(wDeviceNo: Word; dwInitArg: DWord): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pAsb3000StartSampling(wDeviceNo, dwInitArg);
end;
//-------------------------------------------------------------------
// 		TvO̒~
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wStopSampling(wDeviceNo: Word): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pAsb3000StopSampling(wDeviceNo);
end;
//-------------------------------------------------------------------
// 		TvOXe[^X擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				pdwStatus		TvOXe[^X
//				pdwNumData	ǃTvOf[^
//				pvInitArg		\
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wGetStatus(wDeviceNo: Word;
													 var pdwStatus: DWord;
                           var pdwNumData: DWord;
                           var pvInitArg): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pAsb3000GetStatus(wDeviceNo, pdwStatus, pdwNumData, pvInitArg);
end;
//-------------------------------------------------------------------
// 		TvOf[^擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				dwNumData		擾f[^
//				pdwData			擾f[^i[̈ւ̃|C^
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Asb3000wGetData(wDeviceNo: Word;
												 dwNumData: DWord;
                         var pdwData): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pAsb3000GetData(wDeviceNo, dwNumData, pdwData);
end;
//-------------------------------------------------------------------
// 		G[R[h̎擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
// ߂l G[R[h
//-------------------------------------------------------------------
function Asb3000wGetLastError(wDeviceNo: Word): DWord;
begin
	Result := ASB3000_ERR_WRAPDLL;
  if hDLL = 0 then Exit;
  Result := pAsb3000GetLastError(wDeviceNo);
end;
//-------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//-------------------------------------------------------------------
function _GetDllExportFunc: Boolean;
begin
	Result := False;

  // Asb3000GetVersioñAhX擾
  pAsb3000GetVersion := GetProcAddress(hDLL, 'Asb3000GetVersion');
  if @pAsb3000GetVersion = nil then Exit;
  // Asb3000CreatẽAhX擾
  pAsb3000Create := GetProcAddress(hDLL, 'Asb3000Create');
  if @pAsb3000Create = nil then Exit;
  // Asb3000ClosẽAhX擾
  pAsb3000Close := GetProcAddress(hDLL, 'Asb3000Close');
  if @pAsb3000Close = nil then Exit;
  // Asb3000GetDevInfõAhX擾
  pAsb3000GetDevInfo := GetProcAddress(hDLL, 'Asb3000GetDevInfo');
  if @pAsb3000GetDevInfo = nil then Exit;
  // Asb3000GetMemSizẽAhX擾
  pAsb3000GetMemSize := GetProcAddress(hDLL, 'Asb3000GetMemSize');
  if @pAsb3000GetMemSize = nil then Exit;
  // Asb3000SetModẽAhX擾
  pAsb3000SetMode := GetProcAddress(hDLL, 'Asb3000SetMode');
  if @pAsb3000SetMode = nil then Exit;
  // Asb3000StartSampling̃AhX擾
  pAsb3000StartSampling := GetProcAddress(hDLL, 'Asb3000StartSampling');
  if @pAsb3000StartSampling = nil then Exit;
  // Asb3000StopSampling̃AhX擾
  pAsb3000StopSampling := GetProcAddress(hDLL, 'Asb3000StopSampling');
  if @pAsb3000StopSampling = nil then Exit;
  // Asb3000GetStatus̃AhX擾
  pAsb3000GetStatus := GetProcAddress(hDLL, 'Asb3000GetStatus');
  if @pAsb3000GetStatus = nil then Exit;
  // Asb3000GetDatãAhX擾
  pAsb3000GetData := GetProcAddress(hDLL, 'Asb3000GetData');
  if @pAsb3000GetData = nil then Exit;
  // Asb3000GetLastError̃AhX擾
  pAsb3000GetLastError := GetProcAddress(hDLL, 'Asb3000GetLastError');
  if @pAsb3000GetLastError = nil then Exit;

  // SĂDLLGNX|[g֐AhX擾OK
  Result := True;
end;

end.
