//===================================================================
// asb3000s.cs
//-------------------------------------------------------------------
//
// ASB-3000 Sample
//
//-------------------------------------------------------------------
// CH1CALM͂AgKʒȗÕf[^\܂B
//===================================================================
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SampleAsb3000
{
    public partial class Asb3000s : Form
    {
        private const int WM_USER = 0x400;
        private const int WM_ASB3000_BASE = WM_USER + 100;
        private const int WM_ASB3000_DATA_READY = WM_ASB3000_BASE + Asb3000.WM_DATA_READY;
        private const int WM_ASB3000_ERROR = WM_ASB3000_BASE + Asb3000.WM_DATA_THREAD_ERROR;

        private Asb3000 Asb3000w;
        private Asb3000.TSETMODE mSetMode;
        private short mwDeviceNo;

        public Asb3000s()
        {
            InitializeComponent();
        }

        //-------------------------------------------------------------------
        // 
        //-------------------------------------------------------------------
        private void Asb3000s_Load(object sender, EventArgs e)
        {
            int i;
            int dwDrvVer = 0, dwDllVer = 0, dwMemSize = 0, hwnd;
            short wDeviceNo;
            string szbuf;
            Asb3000.TDEVINFO DevInfo;

            //------------------------------------------------------------
            // 
            //------------------------------------------------------------
            Asb3000w = new Asb3000();
            mSetMode = new Asb3000.TSETMODE();
            mSetMode.dwVoltDiv      = new int[Asb3000.NUM_CH];
            mSetMode.dwVoltPos      = new int[Asb3000.NUM_CH];
            mSetMode.dwVertCoupling = new int[Asb3000.NUM_CH];
            mSetMode.dwBandWidth    = new int[Asb3000.NUM_CH];
            DevInfo = new Asb3000.TDEVINFO();
            DevInfo.VendorID        = new byte[Asb3000.VID_LENGTH];
            DevInfo.ProductID       = new byte[Asb3000.PID_LENGTH];
            for (i = 0; i < Asb3000.VID_LENGTH; i++)
                DevInfo.VendorID[i] = 0;
            for (i = 0; i < Asb3000.PID_LENGTH; i++)
                DevInfo.ProductID[i] = 0;
            DevInfo.FirmVer = 0;
            DevInfo.FpgaVer = 0;
            //------------------------------------------------------------
            // foCX̎gp錾
            //------------------------------------------------------------
            wDeviceNo = Asb3000.DEVICE_AUTO;
            hwnd = this.Handle.ToInt32();			// EChEnh
            if (false == Asb3000w.Create(ref wDeviceNo, hwnd, WM_ASB3000_BASE))
            {
                ErrorMessage(Asb3000.DEVICE_AUTO);
                return;
            }
            szbuf = String.Format("foCX {0}  ̎gp錾܂B",
                                    wDeviceNo);
            ResultMessage(szbuf);
            mwDeviceNo = wDeviceNo;
            //------------------------------------------------------------
            // o[W擾
            //------------------------------------------------------------
            if (false == Asb3000w.GetVersion(ref dwDrvVer, ref dwDllVer))
            {
                ErrorMessage(Asb3000.DEVICE_AUTO);
                return;
            }
            szbuf = String.Concat("o[W\n",
                                    String.Format("   DRV Version : 0x{0:x8}\n",
                                                    dwDrvVer),
                                    String.Format("   DLL Version : 0x{0:x8}",
                                                    dwDllVer));
            ResultMessage(szbuf);
            //------------------------------------------------------------
            // foCX擾
            //------------------------------------------------------------
            if (false == Asb3000w.GetDevInfo(mwDeviceNo, ref DevInfo))
            {
                ErrorMessage(mwDeviceNo);
                return;
            }
            szbuf = String.Concat("foCX\n",
                                    String.Format("   Firm Version : {0:f2}\n",
                                                    DevInfo.FirmVer / 100.0),
                                    String.Format("   FPGA Version : {0:f2} ",
                                                    DevInfo.FpgaVer / 100.0));
            ResultMessage(szbuf);
            //------------------------------------------------------------
            // TCY擾
            //------------------------------------------------------------
            if (false == Asb3000w.GetMemSize(mwDeviceNo, ref dwMemSize))
            {
                ErrorMessage(mwDeviceNo);
                return;
            }
            szbuf = String.Copy("TCY\n");
            if (0 == dwMemSize)
            {
                szbuf = String.Concat(szbuf, "   128K|Cg");
            }
            else
            {
                szbuf = String.Concat(szbuf, "   1M|Cg");
            }
            ResultMessage(szbuf);
            //------------------------------------------------------------
            // TvO샂[h()ݒ
            //------------------------------------------------------------
            mSetMode.dwVoltDiv[Asb3000.CH1] = Asb3000.VOLTDIV_1;	// XP[
            mSetMode.dwVoltDiv[Asb3000.CH2] = Asb3000.VOLTDIV_1;
            mSetMode.dwVoltPos[Asb3000.CH1] = 100;					// |WV
            mSetMode.dwVoltPos[Asb3000.CH2] = 100;
            mSetMode.dwVertCoupling[Asb3000.CH1] = Asb3000.CUP_DC;	// ͌
            mSetMode.dwVertCoupling[Asb3000.CH2] = Asb3000.CUP_DC;
            //------------------------------------------------------------
            // TvO샂[h()ݒ
            //------------------------------------------------------------
            mSetMode.dwMemSize = Asb3000.MEMSIZE_10K;				// TCY
            mSetMode.dwSamplingTime = Asb3000.TIMEDIV_200NS;		// XP[
            mSetMode.dwBandWidth[Asb3000.CH1] = Asb3000.BW_FULL;	// gш
            mSetMode.dwBandWidth[Asb3000.CH2] = Asb3000.BW_FULL;
            mSetMode.dwSamplingMode = Asb3000.SMP_REAL;				// TvO[h
            mSetMode.dwAcqMode = Asb3000.ACQ_SINGLE;				// ANCWV[h
            //------------------------------------------------------------
            // TvO샂[h(gK)ݒ
            //------------------------------------------------------------
            mSetMode.dwTrigMode = Asb3000.TMODE_AUTO;				// gK[h
            mSetMode.dwTrigSource = Asb3000.TSRC_CH1;				// gK\[X
            mSetMode.dwTrigCoupling = Asb3000.TCUP_DC;				// gK͌
            mSetMode.dwTrigSlope = Asb3000.TSLP_POS;				// gKX[v
            mSetMode.dwTrigLevel = 250;								// gKx
            mSetMode.dwTrigPos = 5000;								// gK|WV
            mSetMode.dwTrigDelay = 0;								// gKfBC
            mSetMode.dwTrigPulse = Asb3000.PULSE_NONE;				// pXgK(pX)
            mSetMode.dwTrigPulseWidth = 0;							// pXgK(pX)
            if (false == Asb3000w.SetMode(mwDeviceNo, ref mSetMode))
            {
                ErrorMessage(mwDeviceNo);
                return;
            }
            szbuf = String.Concat("TvO샂[hݒ\n",
                                    " yݒz\n",
                                    String.Format("   CH1 XP[ : {0}\n",
                                                        mSetMode.dwVoltDiv[Asb3000.CH1]),
                                    String.Format("   CH2 XP[ : {0}\n",
                                                        mSetMode.dwVoltDiv[Asb3000.CH2]),
                                    String.Format("   CH1 |WV : {0}\n",
                                                        mSetMode.dwVoltPos[Asb3000.CH1]),
                                    String.Format("   CH2 |WV : {0}\n",
                                                        mSetMode.dwVoltPos[Asb3000.CH2]),
                                    String.Format("   CH1 ͌ : {0}\n",
                                                        mSetMode.dwVertCoupling[Asb3000.CH1]),
                                    String.Format("   CH2 ͌ : {0}\n",
                                                        mSetMode.dwVertCoupling[Asb3000.CH2]),
                                    " yݒz\n",
                                    String.Format("   TCY : {0}\n",
                                                        mSetMode.dwMemSize),
                                    String.Format("   TvO^C : {0}\n",
                                                        mSetMode.dwSamplingTime),
                                    String.Format("   CH1 gш : {0}\n",
                                                        mSetMode.dwBandWidth[Asb3000.CH1]),
                                    String.Format("   CH2 gш : {0}\n",
                                                        mSetMode.dwBandWidth[Asb3000.CH2]),
                                    String.Format("   TvO[h : {0}\n",
                                                        mSetMode.dwSamplingMode),
                                    String.Format("   ANCWV[h : {0}\n",
                                                        mSetMode.dwAcqMode),
                                    " ygKݒz\n",
                                    String.Format("   [h : {0}\n",
                                                        mSetMode.dwTrigMode),
                                    String.Format("   \[X : {0}\n",
                                                        mSetMode.dwTrigSource),
                                    String.Format("   ͌ : {0}\n",
                                                        mSetMode.dwTrigCoupling),
                                    String.Format("   X[v : {0}\n",
                                                        mSetMode.dwTrigSlope),
                                    String.Format("   x : {0}\n",
                                                        mSetMode.dwTrigLevel),
                                    String.Format("   |WV : {0}\n",
                                                        mSetMode.dwTrigPos),
                                    String.Format("   fBC : {0}\n",
                                                        mSetMode.dwTrigDelay),
                                    String.Format("   pX : {0}\n",
                                                        mSetMode.dwTrigPulse),
                                    String.Format("   pX : {0}\n",
                                                        mSetMode.dwTrigPulseWidth));
            ResultMessage(szbuf);
            //------------------------------------------------------------
            // TvOJn
            //------------------------------------------------------------
            ResultMessage("TvOJn܂B");
            if (false == Asb3000w.StartSampling(mwDeviceNo, 0))
            {
                ErrorMessage(mwDeviceNo);
                return;
            }
        }

        //-------------------------------------------------------------------
        // I
        //-------------------------------------------------------------------
        private void Asb3000s_FormClosed(object sender, FormClosedEventArgs e)
        {
            // foCX̎gpJ
            if (false == Asb3000w.Close(mwDeviceNo))
                ErrorMessage(mwDeviceNo);
            ResultMessage("foCXJ܂B");
        }

        //-------------------------------------------------------------------
        // bZ[W̏
        //-------------------------------------------------------------------
        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case WM_ASB3000_DATA_READY:
                    DataReady(m.WParam, m.LParam);
                    break;
                case WM_ASB3000_ERROR:
                    DataThreadError(m.WParam, m.LParam);
                    break;
            }
            base.WndProc(ref m);
        }

        //-------------------------------------------------------------------
        // `f[^
        //-------------------------------------------------------------------
        private void DataReady(IntPtr wParam, IntPtr lParam)
        {
            string szbuf;
            string sztmp;
            int dwData, dwStatus = 0, dwNumData = 0, dwInitArg = 0;
            double dblData;
            short wDevNo;
            int i;

            if (Asb3000.DEVICE_ID != lParam.ToInt32())
                return;
            wDevNo = (short)wParam.ToInt32();
            //------------------------------------------------------
            // TvO~
            //------------------------------------------------------
            if (false == Asb3000w.StopSampling(wDevNo))
            {
                ErrorMessage(wDevNo);
            }
            ResultMessage("TvO~܂B");
            //------------------------------------------------------
            // TvOXe[^X擾
            //------------------------------------------------------
            if (false == Asb3000w.GetStatus(wDevNo, ref dwStatus, ref dwNumData, ref dwInitArg))
            {
                ErrorMessage(wDevNo);
                return;
            }
            szbuf = String.Concat("TvOXe[^X擾\n",
                                    String.Format("   TvOXe[^X : 0x{0:x}\n", dwStatus),
                                    String.Format("   ǃTvOf[^ : {0}", dwNumData));
            ResultMessage(szbuf);
            //------------------------------------------------------
            // TvOf[^擾
            //------------------------------------------------------
            if (dwNumData == 0)
                return;
            int[] dwAdData = new int[dwNumData];
            if (false == Asb3000w.GetData(wDevNo, dwNumData, dwAdData))
            {
                ErrorMessage(wDevNo);
                return;
            }
            szbuf = String.Concat("TvOf[^ ", dwNumData.ToString(), " 擾܂B\n\n",
                                    "CH1 擾f[^\n");
            for (i = 4990; i <= 5010; i++)					// 擾f[^\
            {
                dwData = dwAdData[i] & Asb3000.ADDATA_MASK_BIT;			// CH1
                //dwData = (dwAdData[ i ] >> 16) & Asb3000.ADDATA_MASK_BIT;	// CH2
                dblData = VoltValue(dwData);
                sztmp = String.Format("   {0} : {1} ( {2:f2} )\n", i, dwData, dblData);
                szbuf = String.Concat(szbuf, sztmp);
            }
            szbuf = String.Concat(szbuf,
                                    "\n gKʒu : ",
                                    mSetMode.dwTrigPos.ToString(),
                                    " ̑O10\",
                                    "\n@@JbR͓dl(PmV)");
            ResultMessage(szbuf);
            //----------------------------------------------------------
            // I
            //----------------------------------------------------------
            Close();
        }

        //-------------------------------------------------------------------
        // dlZ
        //-------------------------------------------------------------------
        private double VoltValue(int addata)
        {
            int voltdiv;
            double vfull;

            // Volt/div
            switch (mSetMode.dwVoltDiv[Asb3000.CH1])
            {
                case Asb3000.VOLTDIV_0:
                    voltdiv = 10;
                    break;
                case Asb3000.VOLTDIV_1:
                    voltdiv = 20;
                    break;
                case Asb3000.VOLTDIV_2:
                    voltdiv = 50;
                    break;
                case Asb3000.VOLTDIV_3:
                    voltdiv = 100;
                    break;
                case Asb3000.VOLTDIV_4:
                    voltdiv = 200;
                    break;
                case Asb3000.VOLTDIV_5:
                    voltdiv = 500;
                    break;
                case Asb3000.VOLTDIV_6:
                    voltdiv = 1000;
                    break;
                case Asb3000.VOLTDIV_7:
                    voltdiv = 2000;
                    break;
                default:
                    voltdiv = 0;
                    break;
            }
            // tXP[d(v[u10:1)
            vfull = voltdiv * Asb3000.PROBE_X10 * 10;
            // dlɊZ
            return ((vfull * addata / Asb3000.RES_VERT)
                        - (vfull * mSetMode.dwVoltPos[Asb3000.CH1] / Asb3000.RES_VOLTPOS));
        }

        //-------------------------------------------------------------------
        // `f[^擾pXbhG[
        //-------------------------------------------------------------------
        private void DataThreadError(IntPtr wParam, IntPtr lParam)
        {
            if (Asb3000.DEVICE_ID == lParam.ToInt32())
                ErrorMessage((short)wParam.ToInt32());
        }

        //-------------------------------------------------------------------
        // ʂ\
        //-------------------------------------------------------------------
        private void ResultMessage(string pstrbuf)
        {
            MessageBox.Show(pstrbuf, this.Text,
                                MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        //-------------------------------------------------------------------
        // G[bZ[W\
        //-------------------------------------------------------------------
        private void ErrorMessage(short devno)
        {
            int dwRes = Asb3000w.GetLastError(devno);
            string strbuf;

            strbuf = String.Concat("ASB-3000 error\n\n",
                                    String.Format("Error code: 0x{0:x8}", dwRes));
            MessageBox.Show(strbuf, this.Text,
                                MessageBoxButtons.OK, MessageBoxIcon.Stop);
        }

    }
}