'===================================================================
' asb3000s.vb
'-------------------------------------------------------------------
'
' ASB-3000 Sample
'
'-------------------------------------------------------------------
' CH1CALM͂AgKʒȗÕf[^\܂B
'===================================================================

Option Strict Off
Option Explicit On

Public Class Asb3000s

    Const WM_USER As Integer = &H400
    Const WM_ASB3000_BASE As Integer = WM_USER + 100
    Const WM_ASB3000_DATA_READY As Integer = WM_ASB3000_BASE + Asb3000.WM_DATA_READY
    Const WM_ASB3000_ERROR As Integer = WM_ASB3000_BASE + Asb3000.WM_DATA_THREAD_ERROR

    Private Shared mwDeviceNo As Short
    Private Shared Asb3000w As Asb3000
    Private Shared mSetMode As Asb3000.TSETMODE

    '-------------------------------------------------------------------
    ' 
    '-------------------------------------------------------------------
    Private Sub Asb3000s_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer
        Dim dwDrvVer As Integer, dwDllVer As Integer
        Dim dwMemSize As Integer, hwnd As Integer
        Dim wDeviceNo As Short
        Dim szbuf As String
        Dim DevInfo As Asb3000.TDEVINFO

        '------------------------------------------------------------
        ' 
        '------------------------------------------------------------
        Asb3000w = New Asb3000()
        mSetMode = New Asb3000.TSETMODE()
        mSetMode.dwVoltDiv = New Integer(Asb3000.NUM_CH - 1) {}
        mSetMode.dwVoltPos = New Integer(Asb3000.NUM_CH - 1) {}
        mSetMode.dwVertCoupling = New Integer(Asb3000.NUM_CH - 1) {}
        mSetMode.dwBandWidth = New Integer(Asb3000.NUM_CH - 1) {}
        DevInfo = New Asb3000.TDEVINFO
        DevInfo.VendorID = New Byte(Asb3000.VID_LENGTH - 1) {}
        DevInfo.ProductID = New Byte(Asb3000.PID_LENGTH - 1) {}
        For i = 0 To Asb3000.VID_LENGTH - 1
            DevInfo.VendorID(i) = 0
        Next
        For i = 0 To Asb3000.PID_LENGTH - 1
            DevInfo.ProductID(i) = 0
        Next
        DevInfo.FirmVer = 0
        DevInfo.FpgaVer = 0
        '------------------------------------------------------------
        ' foCX̎gp錾
        '------------------------------------------------------------
        wDeviceNo = Asb3000.DEVICE_AUTO
        hwnd = Me.Handle.ToInt32            ' EChEnh
        If False = Asb3000w.Create(wDeviceNo, hwnd, WM_ASB3000_BASE) Then
            ErrorMessage(Asb3000.DEVICE_AUTO)
            Exit Sub
        End If
        szbuf = String.Format("foCX {0} ̎gp錾܂B", wDeviceNo)
        ResultMessage(szbuf)
        mwDeviceNo = wDeviceNo
        '------------------------------------------------------------
        ' o[W擾
        '------------------------------------------------------------
        If False = Asb3000w.GetVersion(dwDrvVer, dwDllVer) Then
            ErrorMessage(Asb3000.DEVICE_AUTO)
            Exit Sub
        End If
        szbuf = String.Concat("o[W", vbCrLf, _
                                String.Format("   DRV Version : 0x{0:x8}", dwDrvVer), vbCrLf, _
                                String.Format("   DLL Version : 0x{0:x8}", dwDllVer))
        ResultMessage(szbuf)
        '------------------------------------------------------------
        ' foCX擾
        '------------------------------------------------------------
        If False = Asb3000w.GetDevInfo(mwDeviceNo, DevInfo) Then
            ErrorMessage(mwDeviceNo)
            Exit Sub
        End If
        szbuf = String.Concat("foCX", vbCrLf, _
                                String.Format("   Firm Version : {0:f2}", _
                                                DevInfo.FirmVer / 100.0), vbCrLf, _
                                String.Format("   FPGA Version : {0:f2}", _
                                                DevInfo.FpgaVer / 100.0))
        ResultMessage(szbuf)
        '------------------------------------------------------------
        ' TCY擾
        '------------------------------------------------------------
        If False = Asb3000w.GetMemSize(mwDeviceNo, dwMemSize) Then
            ErrorMessage(mwDeviceNo)
            Exit Sub
        End If
        szbuf = String.Copy("TCY" & vbCrLf)
        If 0 = dwMemSize Then
            szbuf = String.Concat(szbuf, "   128K|Cg")
        Else
            szbuf = String.Concat(szbuf, "   1M|Cg")
        End If
        ResultMessage(szbuf)
        '------------------------------------------------------------
        ' TvO샂[h()ݒ
        '------------------------------------------------------------
        mSetMode.dwVoltDiv(Asb3000.CH1) = Asb3000.VOLTDIV_1     ' XP[
        mSetMode.dwVoltDiv(Asb3000.CH2) = Asb3000.VOLTDIV_1
        mSetMode.dwVoltPos(Asb3000.CH1) = 100                   ' |WV
        mSetMode.dwVoltPos(Asb3000.CH2) = 100
        mSetMode.dwVertCoupling(Asb3000.CH1) = Asb3000.CUP_DC   ' ͌
        mSetMode.dwVertCoupling(Asb3000.CH2) = Asb3000.CUP_DC
        '------------------------------------------------------------
        ' TvO샂[h()ݒ
        '------------------------------------------------------------
        mSetMode.dwMemSize = Asb3000.MEMSIZE_10K                ' TCY
        mSetMode.dwSamplingTime = Asb3000.TIMEDIV_200NS         ' XP[
        mSetMode.dwBandWidth(Asb3000.CH1) = Asb3000.BW_FULL     ' gш
        mSetMode.dwBandWidth(Asb3000.CH2) = Asb3000.BW_FULL
        mSetMode.dwSamplingMode = Asb3000.SMP_REAL              ' TvO[h
        mSetMode.dwAcqMode = Asb3000.ACQ_SINGLE                 ' ANCWV[h
        '------------------------------------------------------------
        ' TvO샂[h(gK)ݒ
        '------------------------------------------------------------
        mSetMode.dwTrigMode = Asb3000.TMODE_AUTO                ' gK[h
        mSetMode.dwTrigSource = Asb3000.TSRC_CH1                ' gK\[X
        mSetMode.dwTrigCoupling = Asb3000.TCUP_DC               ' gK͌
        mSetMode.dwTrigSlope = Asb3000.TSLP_POS                 ' gKX[v
        mSetMode.dwTrigLevel = 250                              ' gKx
        mSetMode.dwTrigPos = 5000                               ' gK|WV
        mSetMode.dwTrigDelay = 0                                ' gKfBC
        mSetMode.dwTrigPulse = Asb3000.PULSE_NONE               ' pXgK(pX)
        mSetMode.dwTrigPulseWidth = 0                           ' pXgK(pX)
        If False = Asb3000w.SetMode(mwDeviceNo, mSetMode) Then
            ErrorMessage(mwDeviceNo)
            Exit Sub
        End If
        szbuf = String.Concat("TvO샂[hݒ", vbCrLf, _
                                " yݒz", vbCrLf, _
                                String.Format("   CH1 XP[ : {0}", _
                                                mSetMode.dwVoltDiv(Asb3000.CH1)), vbCrLf, _
                                String.Format("   CH2 XP[ : {0}", _
                                                mSetMode.dwVoltDiv(Asb3000.CH2)), vbCrLf, _
                                String.Format("   CH1 |WV : {0}", _
                                                mSetMode.dwVoltPos(Asb3000.CH1)), vbCrLf, _
                                String.Format("   CH2 |WV : {0}", _
                                                mSetMode.dwVoltPos(Asb3000.CH2)), vbCrLf, _
                                String.Format("   CH1 ͌ : {0}", _
                                                    mSetMode.dwVertCoupling(Asb3000.CH1)), vbCrLf, _
                                String.Format("   CH2 ͌ : {0}", _
                                                    mSetMode.dwVertCoupling(Asb3000.CH2)), vbCrLf, _
                                " yݒz", vbCrLf, _
                                String.Format("   TCY : {0}", _
                                                    mSetMode.dwMemSize), vbCrLf, _
                                String.Format("   TvO^C : {0}", _
                                                    mSetMode.dwSamplingTime), vbCrLf, _
                                String.Format("   CH1 gш : {0}", _
                                                    mSetMode.dwBandWidth(Asb3000.CH1)), vbCrLf, _
                                String.Format("   CH2 gш : {0}", _
                                                    mSetMode.dwBandWidth(Asb3000.CH2)), vbCrLf, _
                                String.Format("   TvO[h : {0}", _
                                                    mSetMode.dwSamplingMode), vbCrLf, _
                                String.Format("   ANCWV[h : {0}", _
                                                    mSetMode.dwAcqMode), vbCrLf, _
                                " ygKݒz", vbCrLf, _
                                String.Format("   [h : {0}", _
                                                    mSetMode.dwTrigMode), vbCrLf, _
                                String.Format("   \[X : {0}", _
                                                    mSetMode.dwTrigSource), vbCrLf, _
                                String.Format("   ͌ : {0}", _
                                                    mSetMode.dwTrigCoupling), vbCrLf, _
                                String.Format("   X[v : {0}", _
                                                    mSetMode.dwTrigSlope), vbCrLf, _
                                String.Format("   x : {0}", _
                                                    mSetMode.dwTrigLevel), vbCrLf, _
                                String.Format("   |WV : {0}", _
                                                    mSetMode.dwTrigPos), vbCrLf, _
                                String.Format("   fBC : {0}", _
                                                    mSetMode.dwTrigDelay), vbCrLf, _
                                String.Format("   pX : {0}", _
                                                    mSetMode.dwTrigPulse), vbCrLf, _
                                String.Format("   pX : {0}", _
                                                    mSetMode.dwTrigPulseWidth))
        ResultMessage(szbuf)
        '------------------------------------------------------------
        ' TvOJn
        '------------------------------------------------------------
        ResultMessage("TvOJn܂B")
        If False = Asb3000w.StartSampling(mwDeviceNo, 0) Then
            ErrorMessage(mwDeviceNo)
            Exit Sub
        End If

    End Sub

    '-------------------------------------------------------------------
    ' I
    '-------------------------------------------------------------------
    Private Sub Asb3000s_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        ' foCX̎gpJ
        If False = Asb3000w.Close(mwDeviceNo) Then
            ErrorMessage(mwDeviceNo)
        End If
        ResultMessage("foCXJ܂B")

    End Sub

    '-------------------------------------------------------------------
    ' bZ[W̏
    '-------------------------------------------------------------------
    Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)

        Select Case m.Msg
            Case WM_ASB3000_DATA_READY
                Call DataReady(m.WParam, m.LParam)
            Case WM_ASB3000_ERROR
                Call DataThreadError(m.WParam, m.LParam)
        End Select
        MyBase.WndProc(m)

    End Sub

    '-------------------------------------------------------------------
    ' `f[^
    '-------------------------------------------------------------------
    Private Sub DataReady(ByVal wParam As IntPtr, ByVal lParam As IntPtr)
        Dim szbuf As String, sztmp As String
        Dim dwData As Integer, dwStatus As Integer, dwNumData As Integer, dwInitArg As Integer
        Dim dblData As Double
        Dim wDevNo As Short
        Dim i As Integer
        Dim dwAdData() As Integer

        If lParam.ToInt32() <> Asb3000.DEVICE_ID Then
            Exit Sub
        End If
        wDevNo = CShort(wParam.ToInt32())
        '------------------------------------------------------
        ' TvO~
        '------------------------------------------------------
        If False = Asb3000w.StopSampling(wDevNo) Then
            ErrorMessage(wDevNo)
            Exit Sub
        End If
        ResultMessage("TvO~܂B")
        '------------------------------------------------------
        ' TvOXe[^X擾
        '------------------------------------------------------
        If False = Asb3000w.GetStatus(wDevNo, dwStatus, dwNumData, dwInitArg) Then
            ErrorMessage(wDevNo)
            Exit Sub
        End If
        szbuf = String.Concat("TvOXe[^X擾", vbCrLf, _
                                String.Format("   TvOXe[^X : &H{0:x}", _
                                                dwStatus), vbCrLf, _
                                String.Format("   ǃTvOf[^ : {0}", _
                                                dwNumData))
        ResultMessage(szbuf)
        '------------------------------------------------------
        ' TvOf[^擾
        '------------------------------------------------------
        If dwNumData = 0 Then
            Exit Sub
        End If
        ReDim dwAdData(dwNumData)
        If False = Asb3000w.GetData(wDevNo, dwNumData, dwAdData) Then
            ErrorMessage(wDevNo)
            Exit Sub
        End If
        szbuf = String.Concat("TvOf[^ ", dwNumData.ToString(), _
                                " 擾܂B", vbCrLf, vbCrLf, _
                                "CH1 擾f[^", vbCrLf)
        For i = 4990 To 5010  ' 擾f[^\
            dwData = dwAdData(i) And Asb3000.ADDATA_MASK_BIT            ' CH1
            'dwData = (dwAdData(i) / &H1000) And Asb3000.ADDATA_MASK_BIT ' CH2
            dblData = VoltValue(dwData)
            sztmp = String.Format("   {0} : {1} ({2:f2})", _
                                    i, dwData, dblData)
            szbuf = String.Concat(szbuf, sztmp, vbCrLf)
        Next
        szbuf = String.Concat(szbuf, vbCrLf, _
                                " gKʒu : ", mSetMode.dwTrigPos.ToString(), _
                                " ̑O10\", vbCrLf, _
                                "@@JbR͓dl(PmV)")
        ResultMessage(szbuf)
        '----------------------------------------------------------
        ' I
        '----------------------------------------------------------
        Me.Close()

    End Sub

    '-------------------------------------------------------------------
    ' dlZ
    '-------------------------------------------------------------------
    Private Function VoltValue(ByVal addata As Integer) As Double
        Dim voltdiv As Integer
        Dim vfull As Double

        ' Volt/div
        Select Case mSetMode.dwVoltDiv(Asb3000.CH1)
            Case Asb3000.VOLTDIV_0
                voltdiv = 10
            Case Asb3000.VOLTDIV_1
                voltdiv = 20
            Case Asb3000.VOLTDIV_2
                voltdiv = 50
            Case Asb3000.VOLTDIV_3
                voltdiv = 100
            Case Asb3000.VOLTDIV_4
                voltdiv = 200
            Case Asb3000.VOLTDIV_5
                voltdiv = 500
            Case Asb3000.VOLTDIV_6
                voltdiv = 1000
            Case Asb3000.VOLTDIV_7
                voltdiv = 2000
            Case Else
                voltdiv = 0
        End Select
        ' tXP[d(v[u10:1)
        vfull = voltdiv * Asb3000.PROBE_X10 * 10
        ' dlɊZ
        Return ((vfull * addata / Asb3000.RES_VERT) _
              - (vfull * mSetMode.dwVoltPos(Asb3000.CH1) / Asb3000.RES_VOLTPOS))

    End Function

    '-------------------------------------------------------------------
    ' `f[^擾pXbhG[
    '-------------------------------------------------------------------
    Private Sub DataThreadError(ByVal wParam As IntPtr, ByVal lParam As IntPtr)

        If lParam.ToInt32() = Asb3000.DEVICE_ID Then
            ErrorMessage(CShort(wParam.ToInt32()))
        End If

    End Sub

    '-------------------------------------------------------------------
    ' ʂ\
    '-------------------------------------------------------------------
    Private Sub ResultMessage(ByRef lpszbuf As String)

        MsgBox(lpszbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Information, Me.Text)

    End Sub

    '-------------------------------------------------------------------
    ' G[bZ[W\
    '-------------------------------------------------------------------
    Private Sub ErrorMessage(ByRef devno As Short)
        Dim dwRes As Integer
        Dim szbuf As String

        dwRes = Asb3000w.GetLastError(devno)
        szbuf = String.Concat("ASB-3000 error", vbCrLf, vbCrLf, _
                                String.Format("Error code: &H{0:x8}", dwRes))
        MsgBox(szbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, Me.Text)

    End Sub

End Class
