//===================================================================
// asb3000.h
//-------------------------------------------------------------------
//
// ASB-3000 Header
//
//===================================================================
#ifndef _ASB3000_H_
#define _ASB3000_H_

#ifdef __cplusplus
extern "C" {
#endif

//-------------------------------------------------------------------
// foCXANZXɊւ`
//-------------------------------------------------------------------
#define ASB3000_MAX_DEVICE				16				// őfoCX
#define ASB3000_DEVICE_AUTO				( (WORD)~0U )	// foCXw
//-------------------------------------------------------------------
// `lɊւ`
//-------------------------------------------------------------------
#define ASB3000_NUM_CH					2				// Ή`l
#define ASB3000_CH1						0				// CH1
#define ASB3000_CH2						1				// CH2
//-------------------------------------------------------------------
// foCXɊւ`
//-------------------------------------------------------------------
#define ASB3000_VID_LENGTH				8				// x_ʕ
#define ASB3000_PID_LENGTH				16				// v_Ngʕ
//-------------------------------------------------------------------
// TvOXe[^X̒`
//-------------------------------------------------------------------
#define ASB3000_STS_STOP				0x00			// CxgȂ(~)
#define ASB3000_STS_PRE_TRIG			0x01			// gK҂ɂȂȌ
#define ASB3000_STS_WAIT_FOR_TRIG		0x03			// gK҂̏
#define ASB3000_STS_TRIG_DETECT			0x07			// gK|
#define ASB3000_STS_AUTO_RUN			0x0B			// ^CAEgt[ōăX^[g
//-------------------------------------------------------------------
// G[R[h̒`
//-------------------------------------------------------------------
#define ASB3000_SUCCESS					0				// ُȂ
#define ASB3000_ERR_SYSTEM				1				// VXeG[
#define ASB3000_ERR_NO_DEVICE			2				// gp\ȃfoCX܂
#define ASB3000_ERR_IN_USE				3				// w̃foCX͎gpł
#define ASB3000_ERR_INVALID_DEVICENO	4				// sȃfoCXʔԍł
#define ASB3000_ERR_INVALID_ARGUMENT	5				// sȈw肳܂
#define ASB3000_ERR_INTERNAL			6				// G[ł
#define ASB3000_ERR_TRANSFER_TIMEOUT	7				// f[^]^CAEgɂȂ܂
#define ASB3000_ERR_TRANSFER_CANCEL		8				// f[^]LZ܂
#define ASB3000_ERR_TRANSFER_FAIL		9				// f[^]s܂
#define ASB3000_ERR_BUFF_OVERFLOW		10				// obt@I[o[t[܂
#define ASB3000_ERR_MEMSIZE				11				// 擾TCYُł
#define ASB3000_ERR_DEVICE				12				// foCXG[ł
//-------------------------------------------------------------------
// bZ[W̒`
//-------------------------------------------------------------------
#define WM_DATA_READY					1				// TvOf[^
#define WM_DATA_THREAD_ERROR			2				// f[^擾pXbhG[
//-------------------------------------------------------------------
// ̑̒`
//-------------------------------------------------------------------
#define ASB3000_DEVICE_ID				0xAB00			// foCXID
#define ASB3000_RES_VERT				1024			// \(1024|Cg)
#define ASB3000_RES_VOLTPOS				500				// d|WV\
#define ADBUFF_MAX_SIZE					1000000			// ݍőf[^
#define ADDATA_MASK_BIT					0x000003FF		// rbg}XN
//-------------------------------------------------------------------
// eݒl̒`
//-------------------------------------------------------------------
// (d)XP[
#define ASB3000_VOLTDIV_0				0				// 10mV  or 100mV
#define ASB3000_VOLTDIV_1				1				// 20mV  or 200mV
#define ASB3000_VOLTDIV_2				2				// 50mV  or 500mV
#define ASB3000_VOLTDIV_3				3				// 100mV or 1V
#define ASB3000_VOLTDIV_4				4				// 200mV or 2V
#define ASB3000_VOLTDIV_5				5				// 500mV or 5V
#define ASB3000_VOLTDIV_6				6				// 1V    or 10V
#define ASB3000_VOLTDIV_7				7				// 2V    or 20V
// v[u
#define ASB3000_PROBE_X1				1				// 1:1
#define ASB3000_PROBE_X10				10				// 10:1
#define ASB3000_PROBE_X100				100				// 100:1
// ͌
#define ASB3000_CUP_DC					0				// DC
#define ASB3000_CUP_AC					1				// AC
// TCY
#define ASB3000_MEMSIZE_10K				0				// 10kPoint
#define ASB3000_MEMSIZE_100K			1				// 100kPoint
#define ASB3000_MEMSIZE_1M				2				// 1MPoint
// ()XP[
#define ASB3000_TIMEDIV_10NS			10				// 10ns
#define ASB3000_TIMEDIV_20NS			20				// 20ns
#define ASB3000_TIMEDIV_50NS			50				// 50ns
#define ASB3000_TIMEDIV_100NS			100				// 100ns
#define ASB3000_TIMEDIV_200NS			200				// 200ns
#define ASB3000_TIMEDIV_500NS			500				// 500ns
#define ASB3000_TIMEDIV_1US				1000			// 1us
#define ASB3000_TIMEDIV_2US				2000			// 2us
#define ASB3000_TIMEDIV_5US				5000			// 5us
#define ASB3000_TIMEDIV_10US			10000			// 10us
#define ASB3000_TIMEDIV_20US			20000			// 20us
#define ASB3000_TIMEDIV_50US			50000			// 50us
#define ASB3000_TIMEDIV_100US			100000			// 100us
#define ASB3000_TIMEDIV_200US			200000			// 200us
#define ASB3000_TIMEDIV_500US			500000			// 500us
#define ASB3000_TIMEDIV_1MS				1000000			// 1ms
#define ASB3000_TIMEDIV_2MS				2000000			// 2ms
#define ASB3000_TIMEDIV_5MS				5000000			// 5ms
#define ASB3000_TIMEDIV_10MS			10000000		// 10ms
// gш
#define ASB3000_BW_FULL					0				// FULL
#define ASB3000_BW_20MHZ				1				// 20MHz
// TvO[h
#define ASB3000_SMP_REAL				0				// ATvO
// ANCWV[h
#define ASB3000_ACQ_SINGLE				0				// VOVbg
#define ASB3000_ACQ_ROLL				1				// [
// gK[h
#define ASB3000_TMODE_AUTO				0				// I[g
#define ASB3000_TMODE_NORMAL			1				// m[}
#define ASB3000_TMODE_FREERUN			2				// t[
// gK\[X
#define ASB3000_TSRC_CH1				0				// CH1
#define ASB3000_TSRC_CH2				1				// CH2
#define ASB3000_TSRC_EXT				2				// O
// gK͌
#define ASB3000_TCUP_DC					0				// DC
#define ASB3000_TCUP_LF					1				// LFrej
#define ASB3000_TCUP_HF					2				// HFrej
// gKX[v
#define ASB3000_TSLP_POS				0				// (オ)
#define ASB3000_TSLP_NEG				1				// ()
// pXgK(pX)
#define ASB3000_PULSE_NONE				0				// gp
#define ASB3000_PULSE_UNDER				1				// pX
#define ASB3000_PULSE_ABOVE				2				// pXȏ

//-------------------------------------------------------------------
// foCX\
//-------------------------------------------------------------------
typedef struct _tdevinfo {
	BYTE	VendorID [ ASB3000_VID_LENGTH ];			// x_ʕ
    BYTE	ProductID[ ASB3000_PID_LENGTH ];			// v_Ngʕ
    BYTE	FirmVer;									// t@[EFÃo[W
    BYTE	FpgaVer;									// FPGÃo[W
} TDEVINFO;
//-------------------------------------------------------------------
// TvOp[^\
//-------------------------------------------------------------------
typedef struct _tsetmode {
	// ݒ
    DWORD	dwVoltDiv [ ASB3000_NUM_CH ];				// (d)XP[
    DWORD	dwVoltPos [ ASB3000_NUM_CH ];				// (d)|WV
    DWORD	dwVertCoupling[ ASB3000_NUM_CH ];			// ͌
	// ݒ
    DWORD	dwMemSize;									// TCY
    DWORD	dwSamplingTime;								// ()XP[
    DWORD	dwBandWidth[ ASB3000_NUM_CH ];				// gш
    DWORD	dwSamplingMode;								// TvO[h
    DWORD	dwAcqMode;									// ANCWV[h
	// gKݒ
    DWORD	dwTrigMode;									// gK[h
    DWORD	dwTrigSource;								// gK\[X
    DWORD	dwTrigCoupling;								// gK͌
    DWORD	dwTrigSlope;								// gKX[v
    DWORD	dwTrigLevel;								// gKx
    DWORD	dwTrigPos;									// gK|WV
    DWORD	dwTrigDelay;								// gKfBC
    DWORD	dwTrigPulse;								// pXgK(pX)
    DWORD	dwTrigPulseWidth;							// pXgK(pX)
} TSETMODE;

//-------------------------------------------------------------------
// API
//-------------------------------------------------------------------
// o[W擾
BOOL
WINAPI
Asb3000GetVersion(
	PDWORD		pdwDrvVer,			// DLL̃o[W
	PDWORD		pdwDllVer );		// Driver̃o[W

// foCX̌
BOOL
WINAPI
Asb3000Create(
	PWORD		pwDeviceNo,			// foCXʔԍ
	HWND		hWnd,				// bZ[W󂯎EBhẼnh
	UINT		uWMBase );			// bZ[WID̒l

// foCX̊J
BOOL
WINAPI
Asb3000Close(
	WORD		wDeviceNo );		// foCXʔԍ

// foCX擾
BOOL
WINAPI
Asb3000GetDevInfo(
	WORD		wDeviceNo,			// foCXʔԍ
	TDEVINFO	*pDevInfo );		// foCX

// TCY擾
BOOL
WINAPI
Asb3000GetMemSize(
	WORD		wDeviceNo,			// foCXʔԍ
	PDWORD		pdwMemSize );		// TCY

// TvO샂[h̐ݒ
BOOL
WINAPI
Asb3000SetMode(
	WORD		wDeviceNo,			// foCXʔԍ
	TSETMODE	*pSetMode );		// ݒ

// TvOJn
BOOL
WINAPI
Asb3000StartSampling(
	WORD		wDeviceNo,			// foCXʔԍ
	DWORD		dwInitArg );		// \

// TvO~
BOOL
WINAPI
Asb3000StopSampling(
	WORD		wDeviceNo );		// foCXʔԍ

// TvOXe[^X擾
BOOL
WINAPI
Asb3000GetStatus(
	WORD		wDeviceNo,			// foCXʔԍ
	PDWORD		pdwStatus,			// TvOXe[^X
	PDWORD		pdwNumData,			// ǃTvOf[^
	PVOID		pvInitArg );		// \

// TvOf[^擾
BOOL
WINAPI
Asb3000GetData(
	WORD		wDeviceNo,			// foCXʔԍ
	DWORD		dwNumData,			// 擾f[^
	PDWORD		pdwData );			// 擾f[^

// G[R[h
DWORD
WINAPI
Asb3000GetLastError(
	WORD		wDeviceNo );		// foCXʔԍ


#ifdef __cplusplus
}
#endif

#endif
